/*
** colormaterial.c - ®ʥޥƥꥢؤ
*/

#include <GL/glut.h>
#include "laconia.h"

void
initialize(void)
{
  glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  gluLookAt( 0.0, 50.0, 100.0,
             0.0,  0.0,   0.0,
             0.0,  1.0,   0.0 );

  glEnable( GL_DEPTH_TEST );
  glEnable( GL_CULL_FACE );

  glEnable( GL_LIGHTING );
  glEnable( GL_LIGHT0 );
  glEnable( GL_NORMALIZE );

  /* glColor*()ڤؤѥ᡼ꤹ */
  glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);

  /* glColor*()ˤޥƥꥢؤͭˤ */
  glEnable( GL_COLOR_MATERIAL );
}

void
display(void)
{
  static GLfloat lightPos[] = { 0.0f, 0.0f, 0.0f, 1.0f };
  static float lightX = -51.0f;

  lightX += 1.0f;
  if( lightX>=51.0f ) lightX -= 101.0f;

  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glPushMatrix();
  glTranslatef( lightX, 30.0f, 0.0f );
  glDisable( GL_LIGHTING );
  glColor3f( 1.0f, 1.0f, 1.0f );
  lacSphere( 1.0, 's' );
  glEnable( GL_LIGHTING );
  glLightfv( GL_LIGHT0, GL_POSITION, lightPos );
  glPopMatrix();

  glPushMatrix();
  glTranslatef( 20.0f, 0.0f, 0.0f );

  /* ޥƥꥢץѥƥ */
  glColor3f( 1.0f, 0.0f, 0.0f );

  lacSphere( 15.0, 's' );
  glPopMatrix();

  glPushMatrix();
  glTranslatef( -20.0f, 0.0f, 0.0f );

  /* ޥƥꥢץѥƥ */
  glColor3f( 0.0f, 1.0f, 0.0f );

  lacMountain( 20.0 );
  glPopMatrix();

  glutSwapBuffers();
}

void
keyboard( unsigned char c, int x, int y )
{
  if( c==27 ) exit( 0 );
}

void
reshape( int w, int h )
{
  glViewport( 0, 0, w, h );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45.0, 1.0, 1.0, 1000.0 );
  glMatrixMode( GL_MODELVIEW );
}

void
animate(void)
{
  glutPostRedisplay();
}

int
main( int argc, char *argv[] )
{
  glutInit( &argc, argv );

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

  glutInitWindowPosition( 100, 100 );
  glutInitWindowSize( 500, 400 );
  glutCreateWindow( argv[0] );

  glutDisplayFunc( display );
  glutKeyboardFunc( keyboard );
  glutReshapeFunc( reshape );
  glutIdleFunc( animate );

  initialize();
  glutMainLoop();
  return 0;
}
