/*
 * drawimage.c
 *
 * fstimage饤֥ȤäSGI᡼եɽΥץ
 * (WindowsǤưǽ)
 *
*/
#include <GL/glut.h>
#include <stdio.h>
#include "sgiimage.h"

static int xsize, ysize;
static unsigned int *image;

void
loadimage(char *imagefile)
{
    /* SGI᡼ե뤫ǡ˥ */
    image = rgbReadImageFile(imagefile, &xsize, &ysize);
    if (!image)
    {
	fprintf(stderr, "Unable to open SGI image file: %s\n", imagefile);
	exit(1);
    }
}

void
initialize(void)
{
    /* ᡼γƹԤbyte饤 */
    glPixelStorei(GL_UNPACK_ALIGNMENT,1);
}

void
display(void)
{
    /* 饹ݥ */
    glRasterPos2i(0,  0);

    /* ᡼ǡɽ */
    glDrawPixels(xsize, ysize, GL_RGBA, GL_UNSIGNED_BYTE, image);
    glFlush();
}

void
reshape(int width, int height)
{
    glViewport(0, 0, width, height);

    glMatrixMode (GL_PROJECTION);
    glLoadIdentity();

    /* ̤Υԥ11б褦˥åԥ󥰥ɥ */
    glOrtho(0.0, ((double)width-1.), 0.0, ((double)height-1.), -1.0, 1.0);
    glMatrixMode (GL_MODELVIEW);
}

void
keyboard(unsigned char key, int x, int y)
{
    const unsigned char ESCAPE_KEY = 0x1B;
    if (key == ESCAPE_KEY) exit(0);
}

int
main(int argc, char **argv)
{
    glutInit( &argc, argv);
    
    if (argc != 2)
    {
        fprintf(stderr,"Usage: %s <sgi-image-file>\n", argv[0]);
        exit(1);
    }
    loadimage(argv[1]);   

    glutInitDisplayMode( GLUT_RGB | GLUT_SINGLE );
    glutInitWindowPosition( 100, 100 );
    glutInitWindowSize( xsize, ysize );
    glutCreateWindow( argv[0] );

    glutReshapeFunc( reshape );
    glutDisplayFunc( display );
    glutKeyboardFunc( keyboard );

    initialize();
    glutMainLoop();
    return 0;
}
