/*
** texclamp.c - 0-1ϰϳΥƥ㡼ɸ
*/

#include <GL/glut.h>
#include "laconia.h"
#include "sgiimage.h"

void
initialize(void)
{
  unsigned int* image;
  GLsizei       width, height;

  glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  gluLookAt( 0.0, 50.0, 100.0,
             0.0,  0.0,   0.0,
             0.0,  1.0,   0.0 );

  glEnable( GL_DEPTH_TEST );
  glEnable( GL_CULL_FACE );

  image = rgbReadImageFile( "./images/ocean.rgb",
                            &width, &height );

  /* ƥ㡼ߥåץޥåפǥåȥå */
  gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width, height,
                     GL_RGBA, GL_UNSIGNED_BYTE, image );

  /* SɸˤĤƥƥ㡼Ķ򥯥ץ⡼ɤˤ */
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,
                   GL_CLAMP );

  glEnable( GL_TEXTURE_2D );
}

void
display(void)
{
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glColor3f( 1.0f, 1.0f, 1.0f );

  glColor3f(1.0f, 1.0f, 1.0f);

  /* 0-1ϰϳΥƥ㡼ɸͤȤ */
  glBegin( GL_POLYGON );
  glTexCoord2f( 0.0f, 0.0f );
  glVertex3f( -35.0f,   0.0f, 0.0f );
  glTexCoord2f( 2.0f, 0.0f );
  glVertex3f(   0.0f, -35.0f, 0.0f );
  glTexCoord2f( 2.0f, 2.0f );
  glVertex3f(  35.0f,   0.0f, 0.0f );
  glTexCoord2f( 0.0f, 2.0f );
  glVertex3f(   0.0f,  35.0f, 0.0f );
  glEnd();

  glutSwapBuffers();
}

void
keyboard( unsigned char c, int x, int y )
{
  if( c==27 ) exit( 0 );
}

void
reshape( int w, int h )
{
  glViewport( 0, 0, w, h );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45.0, 1.0, 1.0, 1000.0 );
  glMatrixMode( GL_MODELVIEW );
}

void
animate(void)
{
  glutPostRedisplay();
}

int
main( int argc, char *argv[] )
{
  unsigned int* image;
  GLsizei       width, height;

  glutInit( &argc, argv );

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

  glutInitWindowPosition( 100, 100 );
  glutInitWindowSize( 500, 400 );
  glutCreateWindow( argv[0] );

  glutDisplayFunc( display );
  glutKeyboardFunc( keyboard );
  glutReshapeFunc( reshape );
  glutIdleFunc( animate );

  initialize();
  glutMainLoop();
  return 0;
}
