/*
** animation.c 
*/

#include <GL/glut.h>


/*  */
void
display(void)
{
    /* ˥᡼ѿ */
    static float offset = 50.0;

    /* ˥᡼ѿη׻ */
    offset += 1.0;
    if(offset > 50.0) offset = -50.0;

    glClear(GL_COLOR_BUFFER_BIT);

    /* offset֤˥ */
    glColor3f(1.0, 1.0, 0.0);
    glRectf(-20.0+offset, -50.0, 20.0+offset, 10.0);

    glutSwapBuffers();
}

void
reshape( int w, int h )
{
  glViewport( 0, 0, w, h );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluOrtho2D( -100.0, 100.0, -100.0, 100.0 );
  glMatrixMode( GL_MODELVIEW );
}

void
keyboard( unsigned char c, int x, int y )
{
  if( c==27 ) exit( 0 );
}

void
animate(void)
{
  glutPostRedisplay();
}

void
initialize(void)
{
  glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );
}

int
main( int argc, char *argv[] )
{
  glutInit( &argc, argv );

  /* ֥Хåեγ */
  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE );

  glutInitWindowPosition( 100, 100 );
  glutInitWindowSize( 500, 400 );
  glutCreateWindow( argv[0] );

  glutDisplayFunc( display );
  glutKeyboardFunc( keyboard );
  glutReshapeFunc( reshape );

  glutIdleFunc( animate );

  initialize();
  glutMainLoop();
  return 0;
}
