/*
** depth.c - ǥץХåե
*/

#include <GL/glut.h>
#include "laconia.h"

void
initialize(void)
{
  glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  gluLookAt( 0.0, 50.0, 100.0,
             0.0,  0.0,   0.0,
             0.0,  1.0,   0.0 );

  /* ǥץƥȤͭˤ */
  glEnable( GL_DEPTH_TEST );

  /* ХåեݥꥴࡼХͭˤ */
  glEnable( GL_CULL_FACE );
}

void
drawArm( float armAngle )
{
  lacArm( 20.0, 4.0, 8.0, 'w' );

  glTranslatef( 20.0, 0.0, 0.0 );

  glRotatef( armAngle, 0.0, 0.0, 1.0 );
  lacArm( 14.0, 4.0, 8.0, 'w' );
}

void
display(void)
{
  static float offsetX = -51.0;
  static float angle = -1.0;
  static float armAngle = 9.0;

  offsetX += 1.0;
  if( offsetX>=51.0 ) offsetX -= 101.0;
  angle += 1.0;
  if( angle>=360.0 ) angle -= 360.0; 
  armAngle += 1.0;
  if( armAngle>=81.0 ) armAngle -= 81.0; 

  /* 顼Хåեȶ˥ǥץХåե⥯ꥢ */
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glPushMatrix();
  glTranslatef( offsetX, 0.0, 0.0 );
  glColor3f( 1.0f, 1.0f, 0.0f );

  /* ɤĤ֤⡼ɤ */
  lacSphere( 10.0, 's' );

  glPopMatrix();

  glPushMatrix();
  glRotatef( angle, 0.0, 1.0, 0.0 );
  glColor3f( 0.0f, 0.0f, 1.0f );

  /* ɤĤ֤⡼ɤ */
  lacCone( 15.0, 15.0, 's' );

  glPopMatrix();

  glPushMatrix();
  glRotatef( -angle, 0.0, 1.0, 0.0 );
  glColor3f( 1.0f, 1.0f, 1.0f );
  drawArm( armAngle );
  glPopMatrix();

  glutSwapBuffers();
}

void
keyboard( unsigned char c, int x, int y )
{
  if( c==27 ) exit( 0 );
}

void
reshape( int w, int h )
{
  glViewport( 0, 0, w, h );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45.0, 1.0, 1.0, 1000.0 );
  glMatrixMode( GL_MODELVIEW );
}

void
animate(void)
{
  glutPostRedisplay();
}

main( int argc, char *argv[] )
{
  glutInit( &argc, argv );

  /* ǥץХåեγ */
  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

  glutInitWindowPosition( 100, 100 );
  glutInitWindowSize( 500, 400 );
  glutCreateWindow( argv[0] );

  glutDisplayFunc( display );
  glutKeyboardFunc( keyboard );
  glutReshapeFunc( reshape );
  glutIdleFunc( animate );

  initialize();
  glutMainLoop();
}
