/*
** texgen.c - ƥ㡼ɸͤμư
*/

#include <GL/glut.h>
#include "laconia.h"
#include "sgiimage.h"

void
initialize(void)
{
  unsigned int* image;
  GLsizei       width, height;

  glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  gluLookAt( 0.0, 50.0, 100.0,
             0.0,  0.0,   0.0,
             0.0,  1.0,   0.0 );

  glEnable( GL_DEPTH_TEST );
  glEnable( GL_CULL_FACE );

  /* 㥤᡼ɤ */
  image = rgbReadImageFile( "./images/cafe.rgb",
                            &width, &height );
  gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width, height,
                     GL_RGBA, GL_UNSIGNED_BYTE, image );
  glEnable( GL_TEXTURE_2D );

  /* ƥ㡼ɸͤμư򥻥åȥåפ */
  glTexGeni( GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );
  glTexGeni( GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );

  /* ƥ㡼ɸͤμưͭˤ */
  glEnable( GL_TEXTURE_GEN_S );
  glEnable( GL_TEXTURE_GEN_T );
}

void
display(void)
{
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  /* ƥ㡼ɸͤϼư */
  lacMountain( 20.0 );

  glutSwapBuffers();
}

void
keyboard( unsigned char c, int x, int y )
{
  if( c==27 ) exit( 0 );
}

void
reshape( int w, int h )
{
  glViewport( 0, 0, w, h );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45.0, 1.0, 1.0, 1000.0 );
  glMatrixMode( GL_MODELVIEW );
}

void
animate(void)
{
  glutPostRedisplay();
}

int
main( int argc, char *argv[] )
{
  unsigned int* image;
  GLsizei       width, height;

  glutInit( &argc, argv );

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

  glutInitWindowPosition( 100, 100 );
  glutInitWindowSize( 500, 400 );
  glutCreateWindow( argv[0] );

  glutDisplayFunc( display );
  glutKeyboardFunc( keyboard );
  glutReshapeFunc( reshape );
  glutIdleFunc( animate );

  initialize();
  glutMainLoop();
  return 0;
}
