/*
 * xm.c
 *
 * Motif Υץץ
 *
 *     toplevel - XmForm - XmPushButton
 *
 * cc -o xm xm.c -lXm -lXt -lX11
 */
#include <X11/Intrinsic.h>
#include <X11/Xm/Xm.h>
#include <X11/Xm/Form.h>
#include <X11/Xm/PushB.h>

void quit(Widget w, XtPointer data, XtPointer callData)
{
    exit(0);
}

int
main(int argc, char *argv[])
{
    Widget toplevel;
    Widget form, pushButton, label;
    Widget message;
    XtAppContext app;
    Arg args[16];
    Cardinal n;
    static String fallbackResources[] = {
	"*geometry: 300x200+100+100",
	"*foreground: black",
	"*background: PaleGreen",
	"*fontList: -adobe-helvetica-*--14-*",
	NULL
    };

   /*
    * ݲ/ϰб
    */
    XtSetLanguageProc(NULL, NULL, NULL);

   /*
    * X Toolkit 
    */
    toplevel = XtAppInitialize(&app, "XmSample", NULL, 0, &argc, argv,
			fallbackResources, NULL, 0);

   /*
    * XmForm åȤ򥯥ꥨ
    */
    form = XtCreateManagedWidget("form", xmFormWidgetClass,
				toplevel, NULL, 0);
   /*
    * XmPushButton åȤ򥯥ꥨ
    *     XmForm åȤα˥å
    */
    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNrightOffset, 5); n++;
    XtSetArg(args[n], XmNbottomOffset, 5); n++;
    XtSetArg(args[n], XmNlabelString,
			XmStringCreate("Quit", XmSTRING_DEFAULT_CHARSET)); n++;
    pushButton = XtCreateManagedWidget("pushButton", xmPushButtonWidgetClass,
				form, args, n);
    XtAddCallback(pushButton, XmNactivateCallback, quit, message);

    XtRealizeWidget(toplevel);

    XtAppMainLoop(app);
    return 0;
}
